diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
index 739f76c45..263d8f18f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
@@ -73,13 +73,13 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
         final int y = tilePos.y();
         final int z = tilePos.z();
 
-        float xMin = x;
-        float xMax = x + 1;
-        float zMin = z;
-        float zMax = z + 1;
+        double xMin = x;
+        double xMax = x + 1;
+        double zMin = z;
+        double zMax = z + 1;
 
-        final float onePix = 1f / 16;
-        final float renderOffset = 0.015625F;
+        final double onePix = 1f / 16;
+        final double renderOffset = 0.015625F;
 
 
         byte type = 0;
@@ -99,99 +99,99 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
         if (type == 0) {
             if (amount != 0) {
                 // Render Dot
-                float w = west ? 0 : onePix * 5;
-                float e = east ? 0 : onePix * 5;
-                float s = south ? 0 : onePix * 5;
-                float n = north ? 0 : onePix * 5;
+                double w = west ? 0 : onePix * 5;
+                double e = east ? 0 : onePix * 5;
+                double s = south ? 0 : onePix * 5;
+                double n = north ? 0 : onePix * 5;
 
-                tessellator.addVertexWithUV(xMax - e, (float) y + renderOffset, zMax - s, cross.getSubIconU(1 - e), cross.getSubIconV(1 - s));
-                tessellator.addVertexWithUV(xMax - e, (float) y + renderOffset, zMin + n, cross.getSubIconU(1 - e), cross.getSubIconV(n));
-                tessellator.addVertexWithUV(xMin + w, (float) y + renderOffset, zMin + n, cross.getSubIconU(w), cross.getSubIconV(n));
-                tessellator.addVertexWithUV(xMin + w, (float) y + renderOffset, zMax - s, cross.getSubIconU(w), cross.getSubIconV(1 - s));
+                tessellator.addVertexWithUV(xMax - e, y + renderOffset, zMax - s, cross.getSubIconU(1 - e), cross.getSubIconV(1 - s));
+                tessellator.addVertexWithUV(xMax - e, y + renderOffset, zMin + n, cross.getSubIconU(1 - e), cross.getSubIconV(n));
+                tessellator.addVertexWithUV(xMin + w, y + renderOffset, zMin + n, cross.getSubIconU(w), cross.getSubIconV(n));
+                tessellator.addVertexWithUV(xMin + w, y + renderOffset, zMax - s, cross.getSubIconU(w), cross.getSubIconV(1 - s));
 
-                tessellator.addVertexWithUV(xMax - e, (float) y + renderOffset, zMax - s, cross.getSubIconU(1 - e), cross.getSubIconV(1 - s));
-                tessellator.addVertexWithUV(xMin + w, (float) y + renderOffset, zMax - s, cross.getSubIconU(w), cross.getSubIconV(1 - s));
-                tessellator.addVertexWithUV(xMin + w, (float) y + renderOffset, zMin + n, cross.getSubIconU(w), cross.getSubIconV(n));
-                tessellator.addVertexWithUV(xMax - e, (float) y + renderOffset, zMin + n, cross.getSubIconU(1 - e), cross.getSubIconV(n));
+                tessellator.addVertexWithUV(xMax - e, y + renderOffset, zMax - s, cross.getSubIconU(1 - e), cross.getSubIconV(1 - s));
+                tessellator.addVertexWithUV(xMin + w, y + renderOffset, zMax - s, cross.getSubIconU(w), cross.getSubIconV(1 - s));
+                tessellator.addVertexWithUV(xMin + w, y + renderOffset, zMin + n, cross.getSubIconU(w), cross.getSubIconV(n));
+                tessellator.addVertexWithUV(xMax - e, y + renderOffset, zMin + n, cross.getSubIconU(1 - e), cross.getSubIconV(n));
 
 
             } else {
-                tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMax, cross.getIconUMax(), cross.getIconVMax());
-                tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMin, cross.getIconUMax(), cross.getIconVMin());
-                tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMin, cross.getIconUMin(), cross.getIconVMin());
-                tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMax, cross.getIconUMin(), cross.getIconVMax());
-
-                tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMax, cross.getIconUMax(), cross.getIconVMax());
-                tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMax, cross.getIconUMin(), cross.getIconVMax());
-                tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMin, cross.getIconUMin(), cross.getIconVMin());
-                tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMin, cross.getIconUMax(), cross.getIconVMin());
+                tessellator.addVertexWithUV(xMax, y + renderOffset, zMax, cross.getIconUMax(), cross.getIconVMax());
+                tessellator.addVertexWithUV(xMax, y + renderOffset, zMin, cross.getIconUMax(), cross.getIconVMin());
+                tessellator.addVertexWithUV(xMin, y + renderOffset, zMin, cross.getIconUMin(), cross.getIconVMin());
+                tessellator.addVertexWithUV(xMin, y + renderOffset, zMax, cross.getIconUMin(), cross.getIconVMax());
+
+                tessellator.addVertexWithUV(xMax, y + renderOffset, zMax, cross.getIconUMax(), cross.getIconVMax());
+                tessellator.addVertexWithUV(xMin, y + renderOffset, zMax, cross.getIconUMin(), cross.getIconVMax());
+                tessellator.addVertexWithUV(xMin, y + renderOffset, zMin, cross.getIconUMin(), cross.getIconVMin());
+                tessellator.addVertexWithUV(xMax, y + renderOffset, zMin, cross.getIconUMax(), cross.getIconVMin());
             }
 
         } else if (type == 1) { // East-West
-            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMin, straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMax, straight.getIconUMin(), straight.getIconVMax());
-
-            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMax, straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMin, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, y + renderOffset, zMin, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, y + renderOffset, zMax, straight.getIconUMin(), straight.getIconVMax());
+
+            tessellator.addVertexWithUV(xMax, y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, y + renderOffset, zMax, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, y + renderOffset, zMin, straight.getIconUMax(), straight.getIconVMin());
         } else { // North-South
-            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMin());
-
-            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMin());
+
+            tessellator.addVertexWithUV(xMax, y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMax());
         }
 
         if (northUp) {
-            tessellator.addVertexWithUV(xMin, (float) y + 1, z + renderOffset, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float) y, z + renderOffset, straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float) y, z + renderOffset, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float) y + 1, z + renderOffset, straight.getIconUMin(), straight.getIconVMax());
-
-            tessellator.addVertexWithUV(xMin, (float) y + 1, z + renderOffset, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float) y + 1, z + renderOffset, straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float) y, z + renderOffset, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float) y, z + renderOffset, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, y + 1, z + renderOffset, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, y, z + renderOffset, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, y, z + renderOffset, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, y + 1, z + renderOffset, straight.getIconUMin(), straight.getIconVMax());
+
+            tessellator.addVertexWithUV(xMin, y + 1, z + renderOffset, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, y + 1, z + renderOffset, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, y, z + renderOffset, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, y, z + renderOffset, straight.getIconUMax(), straight.getIconVMin());
         }
         if (southUp) {
-            tessellator.addVertexWithUV(xMax, (float) y + 1, z + 1 - renderOffset, straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float) y, z + 1 - renderOffset, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float) y, z + 1 - renderOffset, straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float) y + 1, z + 1 - renderOffset, straight.getIconUMin(), straight.getIconVMin());
-
-            tessellator.addVertexWithUV(xMax, (float) y + 1, z + 1 - renderOffset, straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float) y + 1, z + 1 - renderOffset, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float) y, z + 1 - renderOffset, straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float) y, z + 1 - renderOffset, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, y + 1, z + 1 - renderOffset, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, y, z + 1 - renderOffset, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, y, z + 1 - renderOffset, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, y + 1, z + 1 - renderOffset, straight.getIconUMin(), straight.getIconVMin());
+
+            tessellator.addVertexWithUV(xMax, y + 1, z + 1 - renderOffset, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, y + 1, z + 1 - renderOffset, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, y, z + 1 - renderOffset, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, y, z + 1 - renderOffset, straight.getIconUMax(), straight.getIconVMax());
         }
         if (eastUp) {
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y + 1, zMin, straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y, zMin, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y, zMax, straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y + 1, zMax, straight.getIconUMin(), straight.getIconVMin());
-
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y + 1, zMin, straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y + 1, zMax, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y, zMax, straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y, zMin, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, y + 1, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, y, zMin, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, y, zMax, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, y + 1, zMax, straight.getIconUMin(), straight.getIconVMin());
+
+            tessellator.addVertexWithUV(x + 1 - renderOffset, y + 1, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, y + 1, zMax, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, y, zMax, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, y, zMin, straight.getIconUMax(), straight.getIconVMax());
         }
         if (westUp) {
-            tessellator.addVertexWithUV(x + renderOffset, (float) y + 1, zMin, straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(x + renderOffset, (float) y + 1, zMax, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(x + renderOffset, (float) y, zMax, straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(x + renderOffset, (float) y, zMin, straight.getIconUMax(), straight.getIconVMax());
-
-            tessellator.addVertexWithUV(x + renderOffset, (float) y + 1, zMin, straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(x + renderOffset, (float) y, zMin, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(x + renderOffset, (float) y, zMax, straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(x + renderOffset, (float) y + 1, zMax, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + renderOffset, y + 1, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + renderOffset, y + 1, zMax, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + renderOffset, y, zMax, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + renderOffset, y, zMin, straight.getIconUMax(), straight.getIconVMax());
+
+            tessellator.addVertexWithUV(x + renderOffset, y + 1, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + renderOffset, y, zMin, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + renderOffset, y, zMax, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + renderOffset, y + 1, zMax, straight.getIconUMin(), straight.getIconVMin());
         }
 
         return true;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
index 23c959528..6552fb74e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
@@ -94,14 +94,6 @@ public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T> {
     private final @NotNull TilePos queryPos = new TilePos();
     public boolean cullSide(@NotNull WorldSource worldSource, @NotNull TilePosc blockPos, @Nullable Direction direction) {
         if (direction != null) {
-            // Cull world ceiling and floors
-            WorldType worldType = worldSource.getWorldType();
-            if (worldType.hasCeiling() && direction == Direction.UP && blockPos.y() >= worldType.getMaxY(worldSource)) {
-                return true;
-            } else if (direction == Direction.DOWN && blockPos.y() <= worldType.getMinY(worldSource)) {
-                return true;
-            }
-
             TilePos shifted = blockPos.add(direction, this.queryPos);
             if (this.forceCullSelf) {
                 return worldSource.getBlockType(shifted) == this.block || worldSource.isBlockOpaqueCube(shifted);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericCullBounderies.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericCullBounderies.java
new file mode 100644
index 000000000..28c29964d
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericCullBounderies.java
@@ -0,0 +1,36 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericCullBounderies<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public BlockModelGenericCullBounderies(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block, staticModel);
+    }
+
+    public BlockModelGenericCullBounderies(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block, staticModel);
+    }
+
+    @Override
+    public boolean cullSide(@NotNull WorldSource worldSource, @NotNull TilePosc blockPos, @Nullable Direction direction) {
+        if (direction != null) {
+            // Cull world ceiling and floors
+            WorldType worldType = worldSource.getWorldType();
+            if (worldType.hasCeiling() && direction == Direction.UP && blockPos.y() >= worldType.getMaxY(worldSource)) {
+                return true;
+            } else if (worldType.hasFloor() && direction == Direction.DOWN && blockPos.y() <= worldType.getMinY(worldSource)) {
+                return true;
+            }
+        }
+        return super.cullSide(worldSource, blockPos, direction);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlab.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlab.java
index 5d1bcca76..8f7268aa8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlab.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlab.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.block.model.generic;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicSlab;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
@@ -23,9 +24,10 @@ public class BlockModelGenericSlab<T extends BlockLogic> extends BlockModelGener
 
     @Override
     public @NotNull StaticBlockModel getModelFromData(int data) {
-        return switch (data & 0b11) {
-            case 1 -> this.full;
-            case 2 -> this.upper;
+        return switch (data & BlockLogicSlab.MASK_STATE) {
+            case BlockLogicSlab.STATE_LOWER -> this.staticModel;
+            case BlockLogicSlab.STATE_DOUBLE -> this.full;
+            case BlockLogicSlab.STATE_UPPER -> this.upper;
             default -> this.staticModel;
         };
     }
@@ -33,28 +35,25 @@ public class BlockModelGenericSlab<T extends BlockLogic> extends BlockModelGener
     private final @NotNull TilePos queryPos = new TilePos();
     @Override
     public boolean cullSide(@NotNull WorldSource worldSource, @NotNull TilePosc blockPos, @Nullable Direction direction) {
-        int data = worldSource.getBlockData(blockPos);
-        boolean upperFaceVisible = (data & 0b11) == 1 || (data & 0b11) == 2;
-        boolean lowerFaceVisible = (data & 0b11) == 0 || (data & 0b11) == 1;
-
         if (direction != null) {
-            // Cull world ceiling and floors
-            WorldType worldType = worldSource.getWorldType();
-            if (worldType.hasCeiling() && direction == Direction.UP && blockPos.y() >= worldType.getMaxY(worldSource) && upperFaceVisible) {
-                return true;
-            } else if (direction == Direction.DOWN && blockPos.y() <= worldType.getMinY(worldSource) && lowerFaceVisible) {
-                return true;
-            }
+            TilePos otherPos = blockPos.add(direction, this.queryPos);
+            Block<?> otherBlock = worldSource.getBlockType(otherPos);
+            if (otherBlock == this.block) {
+                int thisData = worldSource.getBlockData(blockPos);
+                boolean upperFaceCullable = (thisData & BlockLogicSlab.MASK_STATE) == BlockLogicSlab.STATE_DOUBLE || (thisData  & BlockLogicSlab.MASK_STATE) == BlockLogicSlab.STATE_UPPER;
+                boolean lowerFaceCullable = (thisData & BlockLogicSlab.MASK_STATE) == BlockLogicSlab.STATE_LOWER || (thisData  & BlockLogicSlab.MASK_STATE) == BlockLogicSlab.STATE_DOUBLE;
+
+                int otherData = worldSource.getBlockData(otherPos);
+                boolean upperFaceVisible = (otherData & BlockLogicSlab.MASK_STATE) == BlockLogicSlab.STATE_DOUBLE || (otherData  & BlockLogicSlab.MASK_STATE) == BlockLogicSlab.STATE_UPPER;
+                boolean lowerFaceVisible = (otherData & BlockLogicSlab.MASK_STATE) == BlockLogicSlab.STATE_LOWER || (otherData  & BlockLogicSlab.MASK_STATE) == BlockLogicSlab.STATE_DOUBLE;
 
-            TilePos shifted = blockPos.add(direction, this.queryPos);
-            Block<?> b = worldSource.getBlockType(shifted);
-            if (b == this.block) {
-                int otherData = worldSource.getBlockData(shifted);
-                if (otherData == 1) return true;
-                int selfData = worldSource.getBlockData(blockPos);
-                return selfData == otherData;
+                return switch (direction) {
+                    case UP -> upperFaceCullable && lowerFaceVisible;
+                    case DOWN -> lowerFaceCullable && upperFaceVisible;
+                    default -> (otherData & BlockLogicSlab.MASK_STATE) == BlockLogicSlab.STATE_DOUBLE || thisData == otherData; // Cull sides on double slab or if the slab is on the same side (upper or lower)
+                };
             } else {
-                return worldSource.isBlockOpaqueCube(shifted);
+                return worldSource.isBlockOpaqueCube(otherPos);
             }
         }
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index 039dea3ca..957ee5aad 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -26,7 +26,7 @@ import java.util.ArrayList;
 import java.util.List;
 
 public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
-    public static final float ENTITY_RENDER_SCALE = 16f;
+    public static final float ENTITY_RENDER_SCALE = 15.99f;
     private static final Logger LOGGER = LogUtils.getLogger();
     private final @NotNull List<@Nullable StaticEntityModel> setupModels = new ArrayList<>();
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
index c177b3078..7443850f1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.IArmorWearing;
@@ -104,6 +105,7 @@ public abstract class MobRendererBipedArmored<T extends Mob & IArmorWearing<Huma
             if (!(stack.getItem() instanceof IArmorItem)) {
                 GLRenderer.pushFrame();
                 GLRenderer.enableState(State.CULL_FACE);
+                GLRenderer.setShader(Shaders.ITEM);
                 GLRenderer.modelM4f().scale(-16, 16, 16);
                 GLRenderer.modelM4f().scale(0.6f, 0.6f, 0.6f);
                 GLRenderer.modelM4f().translate(0, 7 / 16f, 0);
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
index c9d62eed1..53a97b5ce 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
@@ -32,13 +32,11 @@ public class ItemModelBow extends ItemModelStandard {
         if (nextArrow != null) {
             GLRenderer.pushFrame();
             if (mirrorX) {
-                GLRenderer.modelM4f().rotateZ(-Math.PI_OVER_2_f);
-            } else {
                 GLRenderer.modelM4f().rotateZ(Math.PI_OVER_2_f);
             }
             GLRenderer.modelM4f().translate(0.0001f, 0.0001f, 0);
             GLRenderer.modelM4f().scale(1, 1, 0.999f);
-            renderCoordinate(tessellator, ItemModelDispatcher.getInstance().getDispatch(nextArrow).getIcon(holder, nextArrow.getDefaultStack()), lightIndex, color, items3d, mirrorX);
+            renderCoordinate(tessellator, ItemModelDispatcher.getInstance().getDispatch(nextArrow).getIcon(holder, nextArrow.getDefaultStack()), lightIndex, color, items3d, !mirrorX);
             GLRenderer.popFrame();
         }
     }
